/* global BDF,Balayage,$$ */

Balayage.List = {};

Balayage.List.init = function (callback) {
    BDF.Ajax.loadBalayageArray(function (balayageArray) {
        balayageArray = Balayage.initArray(balayageArray);
        let $listBody = $$("listpane_body");
        $listBody.html(BDF.render("balayage:list-balayage", balayageArray));
        Balayage.List.initActions();
        BDF.Deploy.init($listBody);
        if (callback) {
            callback();
        }
    });
};

Balayage.List.initActions = function () {
    $$("listpane_button_newbalayage").click(Balayage.Overlay.showBalayageCreationForm);
    var $body = $$("listpane_body");
    BDF.onClick($body, {action: "run"}, function () {
        Balayage.Overlay.showRun(BDF.Pane.getEntryName(this));
    });
    BDF.onClick($body, {action: "balayageremove"}, function () {
        Balayage.Overlay.showBalayageRemoveConfirm(BDF.Pane.getEntryName(this));
    });
    BDF.onClick($body, {action: "newcontent"}, function () {
        Balayage.Overlay.showContentCreationForm(BDF.Pane.getEntryName(this));
    });
    BDF.onClick($body, {action: "load-main"}, function () {
        if (!BDF.confirmUnload()) {
            return false;
        }
        let $reference = BDF.$parents($(this), {role: "content-reference"});
        BDF.Pane.loadOrDestock($reference.data("contentKey"), function () {
            _loadContent($reference, false);
        });
        return false;
    });
    BDF.onClick($body, {action: "load-stock"}, function () {
        let $reference = BDF.$parents($(this), {role: "content-reference"});
        let state = BDF.Pane.State.build();
        if (state.isLoaded($reference.data("contentKey"))) {
            return;
        }
        _loadContent($reference, true);
    });
    
    
    function _loadContent($reference, isInStock) {
        let overlayId = BDF.startRunningOverlay();
        BDF.Ajax.loadBalayageContent($reference.data("balayageName"), $reference.data("contentPath"), function (balayageContent) {
            Balayage.ContentForm.load(balayageContent, isInStock);
            Overlay.end(overlayId);
        });
    }

};

Balayage.List.updateBalayage = function (newBalayageObj) {
    var $currentBalayage = BDF.$({role: "entry", name: newBalayageObj.name});
    BDF.Pane.updateStateClass($currentBalayage, "balayage-state-" + newBalayageObj.state);
    _checkList("_core");
    _checkList("extraction");
    _checkList("xslt");


    function _checkList(subdirName) {
        let $subdirBlock = BDF.$($currentBalayage, {role: "subdir-block", subdirName: subdirName});
        BDF.Pane.updateStateClass(BDF.$($subdirBlock, {role: "subdir-name"}), "balayage-state-" + newBalayageObj[subdirName].state);
        let $subdirUl = BDF.$($currentBalayage, {role: "content-list", subdirName: subdirName});
        BDF.Pane.updateContentList("balayage", $subdirUl, newBalayageObj[subdirName].array);
        if ($subdirUl.children("li").length > 0) {
            BDF.$($subdirBlock, {role: "subdir-name"}).removeClass("balayage-Empty");
        } else {
            BDF.$($subdirBlock, {role: "subdir-name"}).addClass("balayage-Empty");
        }
    }

};