/* global FicheQL */

FicheQL.Field = function (options) {
    this._fieldArray = new Array();
    this.q = "*";
    this.mode = FicheQL.MODE_AND;
    this.scope = FicheQL.SCOPE_TITRE;
    if (options) {
        for(var key in options) {
            if (key.indexOf('_') !== 0) {
                if (key === "scope") {
                    var value = options[key];
                    switch(value) {
                        case FicheQL.SCOPE_TITRE:
                        case FicheQL.SCOPE_ENTETE:
                        case FicheQL.SCOPE_FICHE:
                            this.scope = value;
                            break;
                        default:
                            this.scope = FicheQL.SCOPE_SELECTION;
                            this._fieldArray = value.split(" ");
                    }
                } else {
                    this[key] = options[key];
                }
            }
        }
    }
};

FicheQL.Field.prototype.toXml = function (indent) {
    var xml = '';
    var _indent = function() {
        if (indent >= 0) {
            xml += '\n';
            for(var i = 0; i < indent; i++) {
                xml += '\t';
            }
        }
    };
    _indent();
    xml += '<field-select';
    xml += ' scope="' + FicheQL.escape(this.scope) + '"';
    xml += '>';
    indent++;
    if (this.scope === FicheQL.SCOPE_SELECTION) {
        for(var i = 0, len = this._fieldArray.length; i < len; i++) {
            _indent();
            xml += '<field>' + FicheQL.escape(this._fieldArray[i]) + '</field>';
        }
    }
    _indent();
    xml += '<condition';
    xml += ' q="' + FicheQL.escape(this.q) + '"';
    xml += ' mode="' + FicheQL.escape(this.mode) + '"';
    xml += '/>';
    indent--;
    _indent();
    xml += '</field-select>';
    return xml;
};