<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:draw="urn:oasis:names:tc:opendocument:xmlns:drawing:1.0"  xmlns:svg="urn:oasis:names:tc:opendocument:xmlns:svg-compatible:1.0" version="1.0">

    <xsl:template match="extraitcorpus" mode="MODE_BLOCK">
        <xsl:param name="PARAM_CLASS" select=""/>
        <xsl:apply-templates select="fiche" mode="MODE_BLOCK">
            <xsl:with-param name="PARAM_CLASS" select="$PARAM_CLASS"/>
        </xsl:apply-templates>
    </xsl:template>

    <xsl:template match="extraitcorpus" mode="MODE_LISTITEM">
        <xsl:param name="PARAM_CLASS" select=""/>
        <xsl:apply-templates select="fiche" mode="MODE_LISTITEM">
            <xsl:with-param name="PARAM_CLASS" select="$PARAM_CLASS"/>
        </xsl:apply-templates>
    </xsl:template>

    <xsl:template match="extraitcorpus" mode="MODE_INLINE">
        <xsl:param name="PARAM_SEP" select="' ; '"/>
        <xsl:apply-templates select="fiche" mode="MODE_INLINE">
            <xsl:with-param name="PARAM_SEP" select="$PARAM_SEP"/>
        </xsl:apply-templates>
    </xsl:template>

    <xsl:template match="fiche" mode="MODE_BLOCK">
        <xsl:param name="PARAM_CLASS" select=""/>
        <text:p text:style-name="{$PARAM_CLASS}"><xsl:apply-templates select="." mode="MODE_FICHELINK"/></text:p>
    </xsl:template>

    <xsl:template match="fiche" mode="MODE_LISTITEM">
        <xsl:param name="PARAM_CLASS" select=""/>
        <text:list-item><text:p text:style-name="{$PARAM_CLASS}"><xsl:apply-templates select="." mode="MODE_FICHELINK"/></text:p></text:list-item>
    </xsl:template>

    <xsl:template match="fiche" mode="MODE_INLINE">
        <xsl:param name="PARAM_SEP" select="' ; '"/>
        <xsl:if test="position() &gt; 1"><xsl:value-of select="$PARAM_SEP"/></xsl:if>
        <xsl:apply-templates select="." mode="MODE_FICHELINK"/>
    </xsl:template>

    <xsl:template match="fiche" mode="MODE_FICHELINK">
        <text:a xlink:type="simple">
            <xsl:attribute name="xlink:href">
                <xsl:call-template name="TEMPLATE_FICHEURL">
                    <xsl:with-param name="PARAM_CORPUS" select="@corpus"/>
                    <xsl:with-param name="PARAM_ID" select="@id"/>
                </xsl:call-template>
            </xsl:attribute>
            <xsl:apply-templates select="." mode="MODE_TITLE"/>
        </text:a>
    </xsl:template>

    <xsl:template match="extraitaddenda" mode="MODE_BLOCK">
        <xsl:param name="PARAM_CLASS" select=""/>
        <xsl:param name="PARAM_VERSIONSEP" select="' / '"/>
        <xsl:apply-templates select="document" mode="MODE_BLOCK">
            <xsl:with-param name="PARAM_CLASS" select="$PARAM_CLASS"/>
            <xsl:with-param name="PARAM_VERSIONSEP" select="$PARAM_VERSIONSEP"/>
        </xsl:apply-templates>
    </xsl:template>

    <xsl:template match="extraitaddenda" mode="MODE_LISTITEM">
        <xsl:param name="PARAM_CLASS" select=""/>
        <xsl:param name="PARAM_VERSIONSEP" select="' / '"/>
        <xsl:apply-templates select="document" mode="MODE_LISTITEM">
            <xsl:with-param name="PARAM_CLASS" select="$PARAM_CLASS"/>
            <xsl:with-param name="PARAM_VERSIONSEP" select="$PARAM_VERSIONSEP"/>
        </xsl:apply-templates>
    </xsl:template>

    <xsl:template match="extraitaddenda" mode="MODE_INLINE">
        <xsl:param name="PARAM_SEP" select="' ; '"/>
        <xsl:param name="PARAM_VERSIONSEP" select="' / '"/>
        <xsl:apply-templates select="document" mode="MODE_INLINE">
            <xsl:with-param name="PARAM_SEP" select="$PARAM_SEP"/>
            <xsl:with-param name="PARAM_VERSIONSEP" select="$PARAM_VERSIONSEP"/>
        </xsl:apply-templates>
    </xsl:template>

    <xsl:template match="document" mode="MODE_BLOCK">
        <xsl:param name="PARAM_CLASS" select=""/>
        <xsl:param name="PARAM_VERSIONSEP" select="' / '"/>
        <text:p text:style-name="{$PARAM_CLASS}"><xsl:apply-templates select="." mode="MODE_DOCUMENTLINK">
                <xsl:with-param name="PARAM_VERSIONSEP" select="$PARAM_VERSIONSEP"/>
        </xsl:apply-templates></text:p>
    </xsl:template>

    <xsl:template match="document" mode="MODE_LISTITEM">
        <xsl:param name="PARAM_CLASS" select=""/>
        <xsl:param name="PARAM_VERSIONSEP" select="' / '"/>
        <text:list-item><text:p text:style-name="{$PARAM_CLASS}">
                <xsl:apply-templates select="." mode="MODE_DOCUMENTLINK">
                    <xsl:with-param name="PARAM_VERSIONSEP" select="$PARAM_VERSIONSEP"/>
                </xsl:apply-templates>
        </text:p></text:list-item>
    </xsl:template>

    <xsl:template match="document" mode="MODE_INLINE">
        <xsl:param name="PARAM_SEP" select="' ; '"/>
        <xsl:param name="PARAM_VERSIONSEP" select="' / '"/>
        <xsl:if test="position() &gt; 1"><xsl:value-of select="$PARAM_SEP"/></xsl:if>
        <xsl:apply-templates select="." mode="MODE_DOCUMENTLINK">
            <xsl:with-param name="PARAM_VERSIONSEP" select="$PARAM_VERSIONSEP"/>
        </xsl:apply-templates>
    </xsl:template>

    <xsl:template match="document" mode="MODE_DOCUMENTLINK">
        <xsl:param name="PARAM_VERSIONSEP" select="' / '"/>
        <xsl:value-of select="@basename"/><xsl:text> [&#x00A0;</xsl:text>
        <xsl:apply-templates select="version" mode="MODE_VERSIONLINK">
            <xsl:with-param name="PARAM_VERSIONSEP" select="$PARAM_VERSIONSEP"/>
        </xsl:apply-templates>
        <xsl:text>&#x00A0;]</xsl:text>
    </xsl:template>

    <xsl:template match="version" mode="MODE_VERSIONLINK">
        <xsl:param name="PARAM_VERSIONSEP" select="' / '"/>
        <xsl:if test="position() &gt; 1"><xsl:value-of select="$PARAM_VERSIONSEP"/></xsl:if>
        <text:a xlink:type="simple">
            <xsl:attribute name="xlink:href">
                <xsl:call-template name="TEMPLATE_VERSIONURL">
                    <xsl:with-param name="PARAM_ADDENDA" select="../@addenda"/>
                    <xsl:with-param name="PARAM_ID" select="../@id"/>
                    <xsl:with-param name="PARAM_BASENAME" select="../@basename"/>
                    <xsl:with-param name="PARAM_EXTENSION" select="@extension"/>
                </xsl:call-template>
            </xsl:attribute>
            <xsl:text>.</xsl:text><xsl:value-of select="@extension"/>
        </text:a>
        <xsl:text> (</xsl:text><xsl:apply-templates select="." mode="MODE_VERSIONSIZE"/>)
    </xsl:template>

    <xsl:template match="version" mode="MODE_VERSIONSIZE">
        <xsl:apply-templates select="size" mode="MODE_VERSIONSIZE"/>
    </xsl:template>

    <xsl:template match="size" mode="MODE_VERSIONSIZE">
        <xsl:choose>
            <xsl:when test="label[@xml:lang = $WORKINGLANG]"><xsl:value-of select="label[@xml:lang = $WORKINGLANG]"/></xsl:when>
            <xsl:when test="label"><xsl:value-of select="label[1]"/></xsl:when>
            <xsl:otherwise></xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    
    <xsl:template match="extraitalbum" mode="MODE_BLOCK">
        <xsl:param name="PARAM_CLASS" select=""/>
        <xsl:apply-templates select="illustration" mode="MODE_BLOCK">
            <xsl:with-param name="PARAM_CLASS" select="$PARAM_CLASS"/>
        </xsl:apply-templates>
    </xsl:template>

    <xsl:template match="extraitalbum" mode="MODE_LISTITEM">
        <xsl:param name="PARAM_CLASS" select=""/>
        <xsl:apply-templates select="illustration" mode="MODE_LISTITEM">
            <xsl:with-param name="PARAM_CLASS" select="$PARAM_CLASS"/>
        </xsl:apply-templates>
    </xsl:template>

    <xsl:template match="extraitalbum" mode="MODE_INLINE">
        <xsl:param name="PARAM_SEP" select="' '"/>
        <xsl:apply-templates select="illustration" mode="MODE_INLINE">
            <xsl:with-param name="PARAM_SEP" select="$PARAM_SEP"/>
        </xsl:apply-templates>
    </xsl:template>
    
    <xsl:template match="illustration" mode="MODE_BLOCK">
        <xsl:param name="PARAM_CLASS" select=""/>
        <text:p text:style-name="{$PARAM_CLASS}">
            <xsl:apply-templates select="." mode="MODE_INLINE"/>
        </text:p>
    </xsl:template>

    <xsl:template match="illustration" mode="MODE_LISTITEM">
        <xsl:param name="PARAM_CLASS" select=""/>
        <text:list-item><text:p text:style-name="{$PARAM_CLASS}">
            <xsl:apply-templates select="." mode="MODE_INLINE"/>
        </text:p></text:list-item>
    </xsl:template>

    <xsl:template match="illustration" mode="MODE_INLINE">
        <draw:frame draw:name="{generate-id(.)}" draw:style-name="FbeIllustration" text:anchor-type="as-char" svg:width="{@ratio}cm" svg:height="1cm" draw:z-index="0">
            <draw:image xlink:href="bdf://this/illustrations/{@album}-{@id}" xlink:type="simple" xlink:show="embed" xlink:actuate="onLoad"/>
        </draw:frame>
    </xsl:template>

</xsl:stylesheet>